package storage

import (
	"context"
	"git.sch9.ru/new_gate/ms-tester/internal/models"
	"github.com/jmoiron/sqlx"
	"go.uber.org/zap"
)

type LanguageStorage struct {
	db     *sqlx.DB
	logger *zap.Logger
}

func NewLanguageStorage(db *sqlx.DB, logger *zap.Logger) *LanguageStorage {
	return &LanguageStorage{
		db:     db,
		logger: logger,
	}
}

func (storage *LanguageStorage) ReadLanguageById(ctx context.Context, id int32) (*models.Language, error) {
	var language models.Language
	query := storage.db.Rebind("SELECT * from languages WHERE id=? LIMIT 1")
	err := storage.db.GetContext(ctx, &language, query, id)
	if err != nil {
		return nil, handlePgErr(err)
	}
	return &language, nil
}
